<?php

if(!function_exists('handle_size_tag'))
{
	function handle_size_tag($matches)
	{
		$size = 'xx-small';

		/*
		Font tag sizes 1-7 should be:
		1 = x-small
		2 = small
		3 = medium
		4 = large
		5 = x-large
		6 = xx-large
		7 = ?? in chrome it's 48px
		*/
		if($matches[1] == 1)
			$size = 'x-small';
		else if($matches[1] == 2)
			$size = 'small';
		else if($matches[1] == 3)
			$size = 'medium';
		else if($matches[1] == 4)
			$size = 'large';
		else if($matches[1] == 5)
			$size = 'x-large';
		else if($matches[1] == 6)
			$size = 'xx-large';
		else if($matches[1] == 7)
			$size = '48px';
		else if($matches[1][strlen($matches[1]) - 1] === '%'
			&& is_numeric(substr($matches[1], 0, -1)))
			$size = $matches[1];
		else
		{
			if(!is_numeric($matches[1]))
				$matches[1] = 13;
			else if($matches[1] < 6)
				$matches[1] = 6;
			else if($matches[1] > 48)
				$matches[1] = 48;
			else
				$matches[1] = intval($matches[1]);

			$size = $matches[1] . 'px';
		}

		return "<span style=\"font-size: {$size}\">{$matches[2]}</span>";
	}
}

$pats = array();
$reps = array();

$pats[] = '#\[colou?r=([a-zA-Z]{3,20}|\#[0-9a-fA-F]{6}|\#[0-9a-fA-F]{3})]((?:.(?!\[colou?r))*?)\[/colou?r\]#ms';
$reps[] = '<span style="color: $1">$2</span>';

$pats[] = '#\[font=\'?"?([a-zA-Z ,\-]{3,})"?\'?]((?:.(?!\[font))*?)\[/font\]#ms';
//$reps[] = '<span style="font-family: $1">$1 $2</span>';
$reps[] = '<span style="font-family: $1">$2</span>';

$pats[] = '#\[center]((?:.(?!\[center))*?)\[/center\]\r?\n?#ms';
$reps[] = '<div style="text-align: center">$1</div>';
$pats[] = '#\[left]((?:.(?!\[left))*?)\[/left\]\r?\n?#ms';
$reps[] = '<div style="text-align: left">$1</div>';
$pats[] = '#\[right]((?:.(?!\[right))*?)\[/right\]\r?\n?#ms';
$reps[] = '<div style="text-align: right">$1</div>';
$pats[] = '#\[justify]((?:.(?!\[justify))*?)\[/justify\]\r?\n?#ms';
$reps[] = '<div style="text-align: justify">$1</div>';

foreach($pats as $index => $p)
{
	do {
		$text = preg_replace($p, $reps[$index], $text, -1, $count);
	}
	while($count > 0);
}

do {
	$text = preg_replace_callback('#\[size=([^\]]+)]((?:.(?!\[size))*?)\[/size\]#ms',
		'handle_size_tag',
		$text,
		-1,
		$count);
}
while($count > 0);

